## Requirements
To run `docker-compose --env-file ./.env up` to init your container

To have make installed.

If you don't want to install make you can go to `Makefile` therefore copy the command then paste and execute in your terminal window.

## Report
You can watch my **[report](https://gitea.urkob.com/urko/ess-etl-go/src/branch/master/benchmark_report/Report.md)** to see benchmark results


## Tests
### ETL
To see results you only have to run
```bash
make run_etl
```

### http server
To see results you only have to run
```bash
make run_etl
```

## Benchmark

### http comparision
#### Start your go http server
```bash
go run cmd/server/main.go
```
#### Start your nest server
```bash
cd ~/nest-project-path
```
```bash
npm start
```

Then run benchmark
```bash
make benchmark_server
```

### other tests
To test different tests done on http server response you can do this way:

First start your http server
```bash
make run_server
```

Then play running different tests:

**IMPORTANT** Please do mantain your machine without extra running processes

```bash
make benchmark_go_1000req_15s
```
then try

```bash
make benchmark_go_1000req
```

Now try nest server, remember to first [startup your nest](#start-your-nest-server)
```bash
make benchmark_nest_1000req_15s
```
```bash
make benchmark_nest_1000req
```